package KCSoft.UserInterfaceMenu;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "KCSoft.UserInterfaceMenu", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "KCSoft.UserInterfaceMenu", "main");
        processBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnlpage1 = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnlpage2 = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnlpage3 = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 14;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(8192);
 BA.debugLineNum = 15;BA.debugLine="Activity.LoadLayout(\"Main\")";
Debug.ShouldStop(16384);
mostCurrent._activity.LoadLayout("Main",mostCurrent.activityBA);
 BA.debugLineNum = 17;BA.debugLine="pnlPage1.Initialize(\"\")";
Debug.ShouldStop(65536);
mostCurrent._pnlpage1.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 18;BA.debugLine="pnlPage1.LoadLayout(\"Page1\")";
Debug.ShouldStop(131072);
mostCurrent._pnlpage1.LoadLayout("Page1",mostCurrent.activityBA);
 BA.debugLineNum = 19;BA.debugLine="Activity.AddView(pnlPage1,0,0,100%x,100%y)";
Debug.ShouldStop(262144);
mostCurrent._activity.AddView((android.view.View)(mostCurrent._pnlpage1.getObject()),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA));
 BA.debugLineNum = 20;BA.debugLine="pnlPage1.Visible=False";
Debug.ShouldStop(524288);
mostCurrent._pnlpage1.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 22;BA.debugLine="pnlPage2.Initialize(\"\")";
Debug.ShouldStop(2097152);
mostCurrent._pnlpage2.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 23;BA.debugLine="pnlPage2.LoadLayout(\"Page2\")";
Debug.ShouldStop(4194304);
mostCurrent._pnlpage2.LoadLayout("Page2",mostCurrent.activityBA);
 BA.debugLineNum = 24;BA.debugLine="Activity.AddView(pnlPage2,0,0,100%x,100%y)";
Debug.ShouldStop(8388608);
mostCurrent._activity.AddView((android.view.View)(mostCurrent._pnlpage2.getObject()),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA));
 BA.debugLineNum = 25;BA.debugLine="pnlPage2.Visible=False";
Debug.ShouldStop(16777216);
mostCurrent._pnlpage2.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 27;BA.debugLine="pnlPage3.Initialize(\"\")";
Debug.ShouldStop(67108864);
mostCurrent._pnlpage3.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 28;BA.debugLine="pnlPage3.LoadLayout(\"Page3\")";
Debug.ShouldStop(134217728);
mostCurrent._pnlpage3.LoadLayout("Page3",mostCurrent.activityBA);
 BA.debugLineNum = 29;BA.debugLine="Activity.AddView(pnlPage3,0,0,100%x,100%y)";
Debug.ShouldStop(268435456);
mostCurrent._activity.AddView((android.view.View)(mostCurrent._pnlpage3.getObject()),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA));
 BA.debugLineNum = 30;BA.debugLine="pnlPage3.Visible=False";
Debug.ShouldStop(536870912);
mostCurrent._pnlpage3.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 32;BA.debugLine="Activity.AddMenuItem(\"Page 1\",\"mnuPage1\")";
Debug.ShouldStop(-2147483648);
mostCurrent._activity.AddMenuItem("Page 1","mnuPage1");
 BA.debugLineNum = 33;BA.debugLine="Activity.AddMenuItem(\"Page 2\",\"mnuPage2\")";
Debug.ShouldStop(1);
mostCurrent._activity.AddMenuItem("Page 2","mnuPage2");
 BA.debugLineNum = 34;BA.debugLine="Activity.AddMenuItem(\"Page 3\",\"mnuPage3\")";
Debug.ShouldStop(2);
mostCurrent._activity.AddMenuItem("Page 3","mnuPage3");
 BA.debugLineNum = 35;BA.debugLine="End Sub";
Debug.ShouldStop(4);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static boolean  _activity_keypress(int _keycode) throws Exception{
		Debug.PushSubsStack("Activity_KeyPress (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("KeyCode", _keycode);
 BA.debugLineNum = 45;BA.debugLine="Sub Activity_KeyPress(KeyCode As Int) As Boolean";
Debug.ShouldStop(4096);
 BA.debugLineNum = 46;BA.debugLine="If KeyCode = KeyCodes.KEYCODE_BACK Then";
Debug.ShouldStop(8192);
if (_keycode==anywheresoftware.b4a.keywords.Common.KeyCodes.KEYCODE_BACK) { 
 BA.debugLineNum = 47;BA.debugLine="If pnlPage1.Visible = True Then";
Debug.ShouldStop(16384);
if (mostCurrent._pnlpage1.getVisible()==anywheresoftware.b4a.keywords.Common.True) { 
 BA.debugLineNum = 48;BA.debugLine="pnlPage1.Visible = False";
Debug.ShouldStop(32768);
mostCurrent._pnlpage1.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 49;BA.debugLine="Return True";
Debug.ShouldStop(65536);
if (true) return anywheresoftware.b4a.keywords.Common.True;
 }else 
{ BA.debugLineNum = 50;BA.debugLine="Else If pnlPage2.Visible = True Then";
Debug.ShouldStop(131072);
if (mostCurrent._pnlpage2.getVisible()==anywheresoftware.b4a.keywords.Common.True) { 
 BA.debugLineNum = 51;BA.debugLine="pnlPage2.Visible = False";
Debug.ShouldStop(262144);
mostCurrent._pnlpage2.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 52;BA.debugLine="Return True";
Debug.ShouldStop(524288);
if (true) return anywheresoftware.b4a.keywords.Common.True;
 }else 
{ BA.debugLineNum = 53;BA.debugLine="Else If pnlPage2.Visible = True Then";
Debug.ShouldStop(1048576);
if (mostCurrent._pnlpage2.getVisible()==anywheresoftware.b4a.keywords.Common.True) { 
 BA.debugLineNum = 54;BA.debugLine="pnlPage3.Visible = False";
Debug.ShouldStop(2097152);
mostCurrent._pnlpage3.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 55;BA.debugLine="Return True";
Debug.ShouldStop(4194304);
if (true) return anywheresoftware.b4a.keywords.Common.True;
 }else {
 BA.debugLineNum = 57;BA.debugLine="Return False";
Debug.ShouldStop(16777216);
if (true) return anywheresoftware.b4a.keywords.Common.False;
 }}};
 };
 BA.debugLineNum = 60;BA.debugLine="End Sub";
Debug.ShouldStop(134217728);
return false;
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 41;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(256);
 BA.debugLineNum = 43;BA.debugLine="End Sub";
Debug.ShouldStop(1024);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 37;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(16);
 BA.debugLineNum = 39;BA.debugLine="End Sub";
Debug.ShouldStop(64);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
                if (mostCurrent != null) {
Debug.StartDebugging(mostCurrent.activityBA, 9324, new int[] {3} );}

		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static void killProgram() {
    
            if (main.previousOne != null) {
				Activity a = main.previousOne.get();
				if (a != null)
					a.finish();
			}

}
public static String  _globals() throws Exception{
 BA.debugLineNum = 8;BA.debugLine="Sub Globals";
 BA.debugLineNum = 11;BA.debugLine="Dim pnlPage1, pnlPage2, pnlPage3 As Panel";
mostCurrent._pnlpage1 = new anywheresoftware.b4a.objects.PanelWrapper();
mostCurrent._pnlpage2 = new anywheresoftware.b4a.objects.PanelWrapper();
mostCurrent._pnlpage3 = new anywheresoftware.b4a.objects.PanelWrapper();
 BA.debugLineNum = 12;BA.debugLine="End Sub";
return "";
}
public static String  _mnupage1_click() throws Exception{
		Debug.PushSubsStack("mnuPage1_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 62;BA.debugLine="Sub mnuPage1_Click";
Debug.ShouldStop(536870912);
 BA.debugLineNum = 63;BA.debugLine="pnlPage1.Visible = True";
Debug.ShouldStop(1073741824);
mostCurrent._pnlpage1.setVisible(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 64;BA.debugLine="End Sub";
Debug.ShouldStop(-2147483648);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _mnupage2_click() throws Exception{
		Debug.PushSubsStack("mnuPage2_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 66;BA.debugLine="Sub mnuPage2_Click";
Debug.ShouldStop(2);
 BA.debugLineNum = 67;BA.debugLine="pnlPage2.Visible = True";
Debug.ShouldStop(4);
mostCurrent._pnlpage2.setVisible(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 68;BA.debugLine="End Sub";
Debug.ShouldStop(8);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _mnupage3_click() throws Exception{
		Debug.PushSubsStack("mnuPage3_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 70;BA.debugLine="Sub mnuPage3_Click";
Debug.ShouldStop(32);
 BA.debugLineNum = 71;BA.debugLine="pnlPage3.Visible = True";
Debug.ShouldStop(64);
mostCurrent._pnlpage3.setVisible(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 72;BA.debugLine="End Sub";
Debug.ShouldStop(128);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _process_globals() throws Exception{
 BA.debugLineNum = 2;BA.debugLine="Sub Process_Globals";
 BA.debugLineNum = 6;BA.debugLine="End Sub";
return "";
}
  public Object[] GetGlobals() {
		return new Object[] {"Activity",_activity,"pnlPage1",_pnlpage1,"pnlPage2",_pnlpage2,"pnlPage3",_pnlpage3};
}
}
